      SUBROUTINE readinit()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer i
      character*144 line
      character*1 label
      logical forces
C
      open(25,file="input.file",status="old")
      write(6,*) '**** READING input.file FILE ***'
C     *** fname1 - names of fort.77 files
      CALL read_a_line(25,line)
      read (line,*) fname1
      write(6,*) 'names of fort.77 files : ',fname1
C     *** nread - how often to read snapshots
C     *** nskip - how many to skip in fort.77 files
      CALL read_a_line(25,line)
      read (line,*) nread,nskip
      if (nread.lt.1) then
        write(6,*) 'nread < 1'
        stop
      endif
      if (nskip.lt.0) then
        write(6,*) 'nskip < 0'
        stop
      endif
      write(6,*) '(nread,nskip) = ','(',nread,',',nskip,')'
C     *** npchs - number of molecule types
      CALL read_a_line(25,line)
      read (line,*) npchs
      if (npchs.lt.1) then
        write(6,*) 'npchs < 1'
        stop
      endif
      if (npchs.gt.maxmtypes) then
        write(6,*) 'npchs > maxmtypes'
        stop
      endif
      write(6,*) npchs,' number of molec types'
C     *** molec_labels - molecule names
      CALL read_a_line(25,line)
      read (line,*) (molec_labels(i),i=1,npchs)
      write(6,*) 'molecule labels : ',(molec_labels(i),i=1,npchs)
C     *** iref - reference molecule type
C     *** ilig - linked molecule type
C     *** maxcoor - coordination number
      CALL read_a_line(25,line)
      read(line,*) iref,ilig,maxcoor
      if (iref.lt.1) then
        write(6,*) 'iref < 1'
        stop
      endif
      if (ilig.lt.1) then
        write(6,*) 'ilig < 1'
        stop
      endif
      if (iref.gt.npchs) then
        write(6,*) 'iref > npchs'
        stop
      endif
      if (ilig.gt.npchs) then
        write(6,*) 'ilig > npchs'
        stop
      endif
      if (ilig.eq.iref) then
        write(6,*) 'ilig = iref'
        stop
      endif  
      if (maxcoor.lt.1) then
        write(6,*) 'maxcoor < 1'
        stop
      endif
      write(6,*) '(iref,ilig,maxcoor) = ','(',iref,',',ilig,',',
     $                                      maxcoor,')'
C     *** rmax - maximum distance between molecs. to be linked [Angs.]
      CALL read_a_line(25,line)
      read (line,*) rmax
      if (rmax.le.0.d0) then
        write(6,*) 'rmax <= 0.d0'
        stop
      endif
      write(6,*) 'rmax = ',rmax
      rmax=rmax*rmax
C     *** Rectangular box? Write Forces? Surface(s)? 
      CALL read_a_line(25,line)
      read (line,*) recbox,forces,logsrf
      write(6,*) 'rectangular box? ',recbox
      write(6,*) 'write Forces? ',forces
      write(6,*) 'surface(s)? ',logsrf
      rupdt = .not.forces
C     *** Number of cells
      CALL read_a_line(25,line)
      read (line,*) Ncell
      if (Ncell.lt.1) then
        write(6,*) 'Ncell < 1'
        stop
      end if
      write(6,*) 'number of cells (supercell) = ',Ncell
C     *** maxfil - maximum number of .xyz files
      CALL read_a_line(25,line)
      read (line,*) maxfil
      if (maxfil.lt.1) then
        write(6,*) 'maxfil < 1'
        stop
      endif
      if (maxfil.gt.999) then
        write(6,*) 'maxfil > 999'
        stop
      endif
      write(6,*) 'maximum number of .xyz files = ',maxfil
C 
      close(25)
C
      return
      end
C
      SUBROUTINE read12()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer intert,itype,jtype,nq,iinter,jinter
      integer inontype,jnontype,inb,irow,icol,ibond,ibend
      integer itort,ideform,ii,n2,lstart,istart,iend
      real*8 a,b,c,d,remass,f1,f2,f3
      integer typen(maxtypes,maxtypes)
      character*2 int
      character*3 label1,label2
      character*21 label
      character*144 line
      integer i,nbendt,ntortt,ndeformt
      logical ok
C
C
      ncharge = 0
      lpolarizable=.false.
      open(12,file="ff.dat",status="old") 
      CALL read_a_line(12,line)
      read (line,*) nptypes
      if (nptypes.gt.maxtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'Number of non-bonded types = ',nptypes
        write(6,*) 'maxtypes  = ',maxtypes
        write(6,*) 'Number of non-bonded types is greather' 
     &           //' than maxtypes'
        stop
      endif
      if (nptypes.le.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'Number of non-bonded types = ',nptypes
        stop
      endif
      if (.not.logsrf .and. nptypes.lt.maxtypes) then
        write(6,*) '**** WARNING IN ff.dat FILE ***'
        write(6,*) 'Number of non-bonded types = ',nptypes
        write(6,*) 'maxtypes  = ',maxtypes
        write(6,*) 'Number of non-bonded types is lower' 
     &           //' than maxtypes'
      endif
C
C     *****assign typen initially           
C
      intert = 0
      do itype = 1,nptypes
        do jtype = itype,nptypes
          intert = intert + 1
          typen(itype,jtype) = intert
          typen(jtype,itype) = intert
         end do
      end do
      if (intert.gt.maxnnb) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'intert = ',intert
        write(6,*) 'maxnnb  = ',maxnnb
        write(6,*) 'intert > maxnnb'
        stop
      end if 
      CALL read_a_line(12,line)
      write(6,*) "Nonboned self-terms"
      write(6,*) "Label--A[Kcal/mol]--B[1/Ang.]--C[Ang.**6 Kcal/mol]"
     &         //"--Mass[g/mol]"
      do itype = 1,nptypes
        nq = 0
        read (line,'(a3)') non_labels(itype)                 
        intert =  typen(itype,itype)
        read (line(4:144),*) a,b,c,d,remass
        write(6,'(a3,x,3F15.2,F10.4)')non_labels(itype),a,b,c,remass
        nonbonded(1,intert) = a
        nonbonded(2,intert) = b
        nonbonded(3,intert) = c
        atmasses(itype) = remass
C      
C       *******look for charges for this type
C
        CALL read_a_line(12,line)
        if (line(1:1) .ne. ' ') then
          nq = nq + 1
          write(int,'(i2)') nq
          ncharge = ncharge +  1
          if (ncharge.gt.maxcharges) then
            write(6,*) '**** ERROR IN ff.dat FILE ***'
            write(6,*) 'Number of force center types = ',ncharge
            write(6,*) 'maxcharges  = ',maxcharges
            write(6,*) 'Number of force center types is greather'
     &              //' than maxtypes'
            stop
          endif
          q(ncharge) = 0.0d0
          pol(ncharge) = 0.0d0
          atom_labels(ncharge) = non_labels(itype)//int
          non_of_charge(ncharge) = itype
          write (6,*) 'no charge and polarizability for atom ',
     $                 atom_labels(ncharge),
     $                ' was found:  a zero charge is assumed'
        else
          do while (line(1:1) .eq. ' ')
            nq = nq + 1
            write(int,'(i2)') nq
            ncharge = ncharge + 1
            if (ncharge.gt.maxcharges) then
              write(6,*) '**** ERROR IN ff.dat FILE ***'
              write(6,*) 'Number of force center types = ',ncharge
              write(6,*) 'maxcharges  = ',maxcharges
              write(6,*) 'Number of force center types is greather'
     &                 //' than maxtypes'
              stop
            endif
            atom_labels(ncharge) = non_labels(itype)//int
            read (line(2:144),*) q(ncharge),pol(ncharge)
            write(6,'("Q[e]=",F12.4," pol.[Ang.**3]=",F12.4)')
     &              q(ncharge),pol(ncharge)
            if (.not.lpolarizable .and. pol(ncharge).gt.1.0d-4) 
     &        lpolarizable = .true.
            non_of_charge(ncharge) = itype                   
            CALL read_a_line(12,line)
          end do
        end if
      end do ! next itype
      if (.not.logsrf .and. ncharge.lt.maxcharges) then
        write(6,*) '**** WARNING IN ff.dat FILE ***'
        write(6,*) 'Number of force center types = ',ncharge
        write(6,*) 'maxcharges  = ',maxcharges
        write(6,*) 'Number of force center types is lower'
     &           //' than maxtypes'
      endif
C
C     *****assign default for off diagonal
C
      do itype = 1,nptypes-1
        iinter =  typen(itype,itype)
        do jtype = itype+1,nptypes
          jinter =  typen(jtype,jtype)
          intert =  typen(itype,jtype)
          a = sqrt(nonbonded(1,iinter)*nonbonded(1,jinter))
          b = 0.5*(nonbonded(2,iinter)+nonbonded(2,jinter))
          c = sqrt(nonbonded(3,iinter)*nonbonded(3,jinter))
          nonbonded(1,intert) = a
          nonbonded(2,intert) = b
          nonbonded(3,intert) = c
        end do
      end do
C
C     *****read non-default nonbonded interactions
C
      do while (line(1:1) .ne. '!')
        read(line,'(a3)') label1
        itype = 0
        ok = .false.
        do while (.not.ok .and. itype.lt.nptypes)
          itype = itype + 1
          ok = label1.eq.non_labels(itype)
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN ff.dat FILE ***'
          write(6,*) 'Incorrect atom label'
          stop
        endif 
        read (line(5:7),'(a3)') label2
        jtype = 0
        ok = .false.
        do while (.not.ok .and. jtype.lt.nptypes)
          jtype = jtype + 1
          ok = label2.eq.non_labels(jtype)
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN ff.dat FILE ***'
          write(6,*) 'Incorrect atom label'
          stop
        endif
        if (itype.eq.jtype) then
          write(6,*) '**** ERROR IN ff.dat FILE ***'
          write(6,*) 'Nonbonded interactions for the same atom type'
          stop
        endif
        intert =  typen(itype,jtype)
        read (line(8:144),*) a,b,c
        nonbonded(1,intert) = a
        nonbonded(2,intert) = b
        nonbonded(3,intert) = c
        CALL read_a_line(12,line)
      end do
      write(6,*) "Label1--Label2--A[Kcal/mol]--B[1/Ang.]--"
     &         //"C[Ang.**6 Kcal/mol]"
      do itype = 1,nptypes-1
        do jtype = itype+1,nptypes
          intert =  typen(itype,jtype)
          a = nonbonded(1,intert) 
          b = nonbonded(2,intert)
          c = nonbonded(3,intert) 
          write(6,'(a3,x,a3,x,3F15.2)') non_labels(itype),
     &         non_labels(jtype),a,b,c
        end do
      end do
C
      intert = 0
      do itype = 1,ncharge
        inontype = non_of_charge(itype)                   
        do jtype = itype,ncharge
          jnontype = non_of_charge(jtype)                   
          intert = intert + 1
          if (intert.gt.maxnnb) then
            write(6,*) '**** ERROR IN ff.dat FILE ***'
            write(6,*) 'intert = ',intert
            write(6,*) 'maxnnb  = ',maxnnb
            write(6,*) 'intert > maxnnb'
            stop
          end if
          typee(itype,jtype) = intert
          typee(jtype,itype) = intert
          inb = typen(inontype,jnontype)
          map(intert) = inb
         end do
      end do
      do irow = 1,ncharge
        do icol = irow,ncharge
          itype = typee(irow,icol)
          electrostatic(itype) = elecct*q(irow)*q(icol)
        end do
      end do
C
C     *****valence force field
C
      CALL read_a_line(12,line)
      read (line,*) nbondt
      if (nbondt.gt.maxbtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'    
        write(6,*) 'nbondt = ',nbondt
        write(6,*) 'maxbtypes = ',maxbtypes
         write(6,*) 'nbondt > maxbtypes'
        stop
      end if     
      if (nbondt.lt.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'nbondt = ',nbondt
        stop
      end if
      if (nbondt.gt.0) then
        write(6,*) "Bonds"
        write(6,*) "Labels--Kbond[Kcal/(mol Ang.**2)]--R0[Ang.]--"
     &           //"Rconst[Ang.]"
        do ibond = 1,nbondt
          CALL read_a_line(12,line)
          label = line(1:11)
          read (line(12:144),*) f1,f2,f3
          write(6,'(a10,x,3F12.3)') label,f1,f2,f3
          stretch(1,ibond) = f1
          stretch(2,ibond) = f2
          stretch(3,ibond) = f3
        end do
      end  if
      CALL read_a_line(12,line)
      read (line,*) nbendt
      if (nbendt.gt.maxbtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'nbendt = ',nbendt
        write(6,*) 'maxbtypes = ',maxbtypes
        write(6,*) 'nbendt > maxbtypes'
        stop
      end if
      if (nbendt.lt.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'nbendt = ',nbendt
        stop
      end if
      if (nbendt.gt.0) then
        write(6,*) "Bends"
        write(6,*) "Labels--Kbend[Kcal/(mol rad****2)]--"
     &           //"Theta0[degress]"
        do ibend = 1,nbendt
          CALL read_a_line(12,line)
          label = line(1:15)
          read (line(16:144),*) f1,f2
          write(6,'(a15,x,2F12.3)') label,f1,f2
          bend(1,ibend) = f1
          bend(2,ibend) = f2
        end do
      end if  
      CALL read_a_line(12,line)
      read (line,*) ntortt
      if (ntortt.gt.maxbtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ntortt = ',ntortt
        write(6,*) 'maxbtypes = ',maxbtypes
        write(6,*) 'ntortt > maxbtypes'
        stop
      end if
      if (ntortt.lt.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ntortt = ',ntortt
        stop
      end if
      if (ntortt.gt.0) then
        write(6,*) "Torsions"
        write(6,*) "Labels--n--K0,K1,...,Kn[Kcal/mol]"
        do itort = 1,ntortt
          CALL read_a_line(12,line)
          label = line(1:20)
          lstart = 21
          CALL parse_line(line,lstart,istart,iend)
          read(line(istart:iend),*) n2
          if ((n2-1).gt.maxfolds) then
            write(6,*) '**** ERROR IN ff.dat FILE ***'
            write(6,*) 'n2 -1 = ',n2-1
            write(6,*) 'maxfolds = ',maxfolds
            write(6,*) '(n2-1) > maxfolds'
            stop
          end if
          lstart = iend + 1
          read (line(lstart:144),*) (twist(ii,itort),ii=0,n2-1)
          write(6,'(a20,x,I5,8F9.5)')label,n2,(twist(ii,itort),
     &                                         ii=0,n2-1)
          nprms(itort) = n2
        end do
      end if
      CALL read_a_line(12,line)
      read (line,*) ndeformt
      if (ndeformt.gt.maxbtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ndeformt = ',ndeformt
        write(6,*) 'maxbtypes = ',maxbtypes
        write(6,*) 'ndeformt > maxbtypes'
        stop
      end if
      if (ndeformt.lt.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ndeformt = ',ndeformt
        stop
      end if
      if (ndeformt.gt.0) then
        write(6,*) "Deformations"
        write(6,*) "Labels--K[Kcal/(mol rad****2)]"
        do ideform = 1,ndeformt
          CALL read_a_line(12,line)
          label = line(1:20)
          read (line(21:144),*) f1
          write(6,'(a20,x,F10.3)') label,f1
          deform(ideform) = f1
        end do
      end if
      CALL read_a_line(12,line)
      read (line,*) ndummytypes
      if (ndummytypes.gt.maxdummy) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ndummytypes = ',ndummytypes
        write(6,*) 'maxdummy = ',maxdummy
        write(6,*) 'ndummytypes > maxdummy'
        stop
      end if
      if (ndummytypes.lt.0) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'ndummytypes = ',ndummytypes
        stop
      end if
      do i=1,ncharge
        typedummy(i)=0
      end do
      if (ndummytypes.gt.0) then
        write(6,*) "Dummy atoms"
        write(6,*) "Labels--Charge index--la--lb[Ang.]--lc[Ang.]--"
     &           //"types"
        do itype=1,ndummytypes
          CALL read_a_line(12,line)
          label = line(1:20)
          read(line(21:144),*) i,adummy(itype),bdummy(itype),
     &                       cdummy(itype),LpGeomType(itype),
     &    LpBendAtomType(1,itype),LpBendAtomType(2,itype),
     &    LpBendAtomType(3,itype) 
          write(6,'(a20,I3,3F12.4,4I3)') label,i,adummy(itype),
     &        bdummy(itype),cdummy(itype),LpGeomType(itype),
     &    LpBendAtomType(1,itype),LpBendAtomType(2,itype),
     &    LpBendAtomType(3,itype) 
          typedummy(i)=itype
        end do
      end if
C
      close(12)
C
      return
      end
C
      SUBROUTINE read11()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer iat,ibond,itbond,j,ibend,ib1,ib2,nchains
      integer itemp,ich,icheck1,icheck2,itort,ideform,ib
      integer iba,itest,itbend,ittort,itdefs,ibase
      integer nbendsch(maxnch),ntortsch(maxnch),ndeformsch(maxnch),
     &        nbondex(maxnch)
      character*144 line
      logical ok
C
C
C     *****read in data
C
      itbond = 0
      itbend = 0
      ittort = 0
      itdefs = 0
      open(11,file="connectivity.dat",status="old")
      CALL read_a_line(11,line)
      read (line,*) nchains, nions
      if (nchains.lt.0) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nchains = ',nchains
        stop
      end if
      if (nions.lt.0) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nions = ',nions
        stop
      end if
      nch = nchains + nions
      if (nch.gt.maxnch) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nch = ',nch
        write(6,*) 'maxnch = ',maxnch
        write(6,*) 'nch > maxnch'
        stop
      end if
      if (nch.lt.maxnch) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'nch = ',nch
        write(6,*) 'maxnch = ',maxnch
        write(6,*) 'nch < maxnch'
      end if
      nat = 0
      nbonds = 0
      nbends = 0
      ntorts = 0
      ndeforms = 0
      do ich = 1, nch
        CALL read_a_line(11,line)
        read (line,*) natch(ich),nbondsch(ich),
     &     nbendsch(ich),ntortsch(ich),ndeformsch(ich)
        if (natch(ich).le.0) then
          write(6,*) '**** ERROR IN connectivity.dat FILE ***'
          write(6,*) 'chain ',ich,' has ',natch(ich),' atoms'
          stop
        end if
        if (nbondsch(ich).lt.0) then
          write(6,*) '**** ERROR IN connectivity.dat FILE ***'
          write(6,*) 'chain ',ich,' has ',nbondsch(ich),' bonds'
          stop
        end if
        if (nbendsch(ich).lt.0) then
          write(6,*) '**** ERROR IN connectivity.dat FILE ***'
          write(6,*) 'chain ',ich,' has ',nbendsch(ich),' bends'
          stop
        end if
        if (ntortsch(ich).lt.0) then
          write(6,*) '**** ERROR IN connectivity.dat FILE ***'
          write(6,*) 'chain ',ich,' has ',ntortsch(ich),' torsions'
          stop
        end if
        if (ndeformsch(ich).lt.0) then
          write(6,*) '**** ERROR IN connectivity.dat FILE ***'
          write(6,*) 'chain ',ich,' has ',ndeformsch(ich),
     &               ' deformations'
          stop
        end if
        nat = nat + natch(ich)
        nbondex(ich) = nbonds
        nbonds = nbonds + nbondsch(ich)
        nbends = nbends + nbendsch(ich)
        ntorts = ntorts + ntortsch(ich)
        ndeforms = ndeforms + ndeformsch(ich)
      end do
      if (nat.gt.maxat) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nat = ',nat
        write(6,*) 'maxat = ',maxat
        write(6,*) 'nat > maxat'
        stop
      end if
      if (.not.logsrf .and. nat.lt.maxat) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'nat = ',nat
        write(6,*) 'maxat = ',maxat
        write(6,*) 'nat < maxat'
      end if
      if (nbonds.gt.maxbonds) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nbonds = ',nbonds
        write(6,*) 'maxbonds = ',maxbonds
        write(6,*) 'nbonds > maxbonds'
        stop
      end if
      if (nbonds.lt.maxbonds) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'nbonds = ',nbonds
        write(6,*) 'maxbonds = ',maxbonds
        write(6,*) 'nbonds < maxbonds'
      end if
      if (nbends.gt.maxbends) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'nbends = ',nbends
        write(6,*) 'maxbends = ',maxbends
        write(6,*) 'nbends > maxbends'
        stop
      end if
      if (nbends.lt.maxbends) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'nbends = ',nbends
        write(6,*) 'maxbends = ',maxbends
        write(6,*) 'nbends < maxbends'
      end if 
      if (ntorts.gt.maxtorts) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'ntorts = ',ntorts
        write(6,*) 'maxtorts = ',maxtorts
        write(6,*) 'ntorts > maxtorts'
        stop
      end if
      if (ntorts.lt.maxtorts) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'ntorts = ',ntorts
        write(6,*) 'maxtorts = ',maxtorts
        write(6,*) 'ntorts < maxtorts'
      end if
      if (ndeforms.gt.maxdeforms) then
        write(6,*) '**** ERROR IN connectivity.dat FILE ***'
        write(6,*) 'ndeforms = ',ndeforms
        write(6,*) 'maxdeforms = ',maxdeforms
        write(6,*) 'ndeforms > maxdeforms'
        stop
      end if
      if (ndeforms.lt.maxdeforms) then
        write(6,*) '**** WARNING IN connectivity.dat FILE ***'
        write(6,*) 'ndeforms = ',ndeforms
        write(6,*) 'maxdeforms = ',maxdeforms
        write(6,*) 'ndeforms < maxdeforms'
      end if
      write (6,*) 'nat = ',nat
      write (6,*) 'nbonds = ',nbonds
      write (6,*) 'nbends = ',nbends
      write (6,*) 'ntorts = ',ntorts
      write (6,*) 'ndeforms = ',ndeforms
      write (6,*) 'nions = ',nions
      write (6,*) 'reading bonds'
      do ich = 1,nch
        if (nbondsch(ich) .eq. 0)then
          CALL read_a_line(11,line)
          read (line,*) iat
          chain(iat) = ich
        end if
        ibond = 0
        do while (ibond.lt.nbondsch(ich))
          ibond = ibond + 1 
          CALL read_a_line(11,line)
          itbond = itbond + 1
          read (line,*) (bonds(j,itbond), j=1,3)
          if (bonds(1,itbond).ge.bonds(2,itbond)) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write(6,*) '**** wrong arrangement for bonded force' 
     &               //' centers'
            stop
          end if
        end do
      end do
      write (6,*) 'reading bends'
      do ich = 1,nch
        ibase = nbondex(ich)
        ibend = 0
        do while (ibend.lt.nbendsch(ich))
          ibend = ibend + 1
          CALL read_a_line(11,line)
          itbend = itbend + 1
          read (line,*) (bends(j,itbend), j=1,4)
C
C     *****determine which bonds make up each bend
C
          ib1 = bends(1,itbend)
          ib2 = bends(2,itbend)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then 
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'bend:first bond not found'
            stop
          endif
          ib1 = bends(2,itbend)
          ib2 = bends(3,itbend)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'bend:second bond not found'
            stop
          endif
        end do
      end do
      write (6,*) 'reading torsions'
      do ich = 1,nch
        ibase = nbondex(ich)
        itort = 0
        do while (itort.lt.ntortsch(ich))
          itort = itort + 1
          CALL read_a_line(11,line)
          ittort = ittort + 1
          read (line,*) (torts(j,ittort), j=1,5)
C
C     *****determine which bonds make up each torsion
C
          ib1 = torts(1,ittort)
          ib2 = torts(2,ittort)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:first bond not found'
            stop
          endif
          ib1 = torts(2,ittort)
          ib2 = torts(3,ittort)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:second bond not found'
            stop
          endif
          ib1 = torts(3,ittort)
          ib2 = torts(4,ittort)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:third bond not found'
            stop
          endif
        end do
      end do
      write (6,*) 'reading deformations'
      do ich = 1,nch
        ibase = nbondex(ich)
        ideform = 0
        do while (ideform.lt.ndeformsch(ich))
          ideform = ideform + 1
          CALL read_a_line(11,line)
          itdefs = itdefs + 1
          read (line,*) (deforms(j,itdefs), j=1,5)
C
C     *****determine which bonds make up each deformation
C
          ib1 = deforms(1,itdefs)
          ib2 = deforms(2,itdefs)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:first bond not found'
            stop
          endif
          ib1 = deforms(2,itdefs)
          ib2 = deforms(3,itdefs)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:second bond not found'
            stop
          endif
          ib1 = deforms(2,itdefs)
          ib2 = deforms(4,itdefs)
          if (ib2 .lt. ib1) then
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            ok = icheck1.eq.ib1 .and. icheck2.eq.ib2
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:third bond not found'
            stop
          endif
        end do
      end do
C
C     *****determine chain of each atom
C
      itbond = 0
      do ich = 1, nch
        ib = 0
        do while (ib.lt.nbondsch(ich))
          ib = ib + 1
          itbond = itbond + 1
          do iba = 1,2
            itest = bonds(iba,itbond)
            chain(itest) = ich
          end do
        end do
      end do
C     
      close(11)
C
      return 
      end 
C
      SUBROUTINE read26()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer kk,iat,lstart,istart,iend,icharge,itype,imap,inos
      character*144 line
      character*5 check
      character*2 intg
      real*8 shift(3),xun(3,maxat)
      logical ok
C
C
C     *****begin read
C
      shift(1) = 10000.d0
      shift(2) = 10000.d0
      shift(3) = 10000.d0
C
C
      do iat = 1, nat
        ldummy(iat)=.false.
      end do
C
      open(26,file="coords.inp",status="old")
      ndummy = 0
      write(6,*) 'atom----label----mass [g/mol]'
      do iat = 1, nat
        CALL read_a_line(26,line)
        lstart = 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(1,iat)
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(2,iat)
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(3,iat)
        do kk = 1,3
         if (x(kk,iat).lt.shift(kk)) shift(kk) = x(kk,iat)
        end do
C
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:istart+2),'(a3)') check 
C
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) icharge
        write (intg,'(i2)') icharge
        check = check(1:3)//intg
C
C       *****assign atom type
C
        itype = 0
        ok = .false.
        do while (.not.ok .and. itype.lt.ncharge)
          itype = itype + 1
          if (check .eq. atom_labels(itype)) then
            atomtype(iat) = itype
            if (typedummy(itype).gt.0) then 
              ldummy(iat) = .true.
              ndummy = ndummy + 1
            end if
            imap = map(itype)
            mass(iat) = atmasses(imap)
            write(6,*) iat,atom_labels(itype),mass(iat)
            ok = .true.
          end if
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN coords.inp FILE ***'
          write (6,*) 'atomtype not found'
          stop
        endif
C
        CALL read_a_line(26,line)
        read (line,*) (v(kk,iat),kk=1,3)
      end do ! next iat
      if (ndummy.gt.maxdummy) then
        write(6,*) '**** ERROR IN coords.inp FILE ***'
        write(6,*) 'ndummy = ',ndummy
        write(6,*) 'maxdummy = ',maxdummy
        write(6,*) 'ndummy > maxdummy'
        stop
      end if
      if (ndummy.lt.maxdummy) then
        write(6,*) '**** WARNING IN coords.inp FILE ***'
        write(6,*) 'ndummy = ',ndummy
        write(6,*) 'maxdummy = ',maxdummy
        write(6,*) 'ndummy > maxdummy'
      end if
C
C     ***** read extended lagrangian variables
C
      CALL read_a_line(26,line)
      if (recbox) then
        read(line,*)box(1),box(2),box(3)
        if (box(1).le.0.0d0 .or. box(2).le.0.0d0 .or.
     &      box(3).le.0.0d0) then
          write(6,*) '**** ERROR IN coords.inp FILE ***'
          write (6,*) 'Wrong rectangular box size'
          stop
        end if
        write(6,*)
        write(6,*) "initial box=",box(1),box(2),box(3)
      else
        read(line,*)box(1)
        if (box(1).le.0.0d0) then
          write(6,*) '**** ERROR IN coords.inp FILE ***'
          write (6,*) 'Wrong cubic box size'
          stop
        end if
        box(2) = box(1)
        box(3) = box(1)
        write(6,*)
        write(6,*) "initial box=",box(1)
      end if
      CALL read_a_line(26,line)
      read(line,*)(xlogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)(vlogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)(glogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)xlogv
      CALL read_a_line(26,line)
      read(line,*)vlogv
      CALL read_a_line(26,line)
      read(line,*)glogv
C
C     ***** read forces if it is required
C
      if (.not.rupdt) then
        do iat = 1, nat
          CALL read_a_line(26,line)
          read (line,*) (fnow(kk,iat),kk=1,3)
        end do ! next iat
      end if
C
C     *******shift positions if necessary
C
      if (shift(1) .lt. 0.d0 .or. shift(2) .lt. 0.d0 .or.
     &    shift(3) .lt. 0.d0) then
        write (6,*) 'shifting positions'
        do iat = 1,nat
          do kk = 1,3  
            x(kk,iat) = x(kk,iat) - shift(kk) + 1.d-8
          end do
        end do
      end if
C
C     *****Check if any coordinate is greather than box length
C
      ok = .false.
      iat = 0
      do while (.not.ok .and. iat.lt.nat) 
        iat = iat + 1
        kk = 0
        do while (.not.ok .and. kk.lt.3)
          kk = kk + 1
          ok = x(kk,iat).gt.box(kk)
        end do
      end do   
      if (ok) then
        write(6,*) '**** WARNING IN coords.inp FILE ***'
        write (6,*) 'There exist some coordinates which are'
     &            //' greather than box length.'
        write (6,*) 'PBC has been applied'
        call unwrap(x,xun)
        do iat = 1, nat
          do kk = 1,3  
            if (xun(kk,iat).gt.box(kk)) 
     &        xun(kk,iat) = xun(kk,iat) - box(kk)
            if (xun(kk,iat).lt.0.0) 
     &        xun(kk,iat) = xun(kk,iat) + box(kk)
            x(kk,iat) = xun(kk,iat)
          end do 
        end do  
      endif
C
      close(26)
C
      return
      end
C
      SUBROUTINE read_a_line(iunit,line)
C
      implicit none
C
C     *****shared variables
C
      integer iunit
      character*144 line
C
1     read(iunit,'(a144)',end=100) line
      if (line(1:1) .eq. '*') goto 1
      return
100   continue
      write (6,*) 'end of file ',iunit,' was reached'
      stop
      end
C
      SUBROUTINE parse_line(line,lstart,istart,iend)
C
      implicit none
C
C     *****shared variables
C
      integer lstart,istart,iend
      character*144 line
C
C     *****local variables
C
      character*1 value
      integer ipos
C
      ipos = lstart -1
      value = ' '
      do while (value .eq. ' ')
        ipos = ipos + 1
        value = line(ipos:ipos)
      end do
      istart = ipos
      do while (value .ne. ' ')
        ipos = ipos + 1
        value = line(ipos:ipos)
      end do
      iend = ipos - 1
C
      return
      end
C
      SUBROUTINE unwrap(xrf,xunrf)
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer iat,jat,ibond,kk
      real*8 xrf(3,maxat),xunrf(3,maxat),diff
C
      do kk = 1,3
        el2(kk) = box(kk)*0.5d0
      end do
      do iat = 1,nat
        do kk = 1,3
          xunrf(kk,iat) = xrf(kk,iat)
         end do
      end do
C
C     *****unwrap by bonds
C
      do ibond = 1,nbonds
        iat = bonds(1,ibond)
        jat = bonds(2,ibond)
        do kk = 1,3
          diff = xrf(kk,jat) - xrf(kk,iat)
          if (abs(diff).gt.el2(kk))
     &      diff = diff - dsign(box(kk),diff)
          xunrf(kk,jat) = xunrf(kk,iat) + diff
        end do
      end do
C
      return
      end
