      SUBROUTINE readinit()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      character*144 line
      integer       i
C
      open(25,file="input.file",status="old")
      write(6,*) '**** READING input.file FILE ***'
c     reading file for fort.77 files
      CALL read_a_line(25,line)
      read (line,*) fname1
      write(6,*) fname1,' file for fort.77 files'
c     reading frequency and init value
      CALL read_a_line(25,line)
      read (line,*) nread,nskip
      if (nread.lt.1) then
        write(6,*) 'nread < 1'
        stop
      end if
      if (nskip.lt.0) then
        write(6,*) 'nskip < 0'
        stop
      end if
      write(6,*) '(nskip,nread)=(',nskip,',',nread,')'
c     reading temperature (K)
      CALL read_a_line(25,line)
      read (line,*) temper
      if (temper.lt.0.d0) then
        write(6,*) 'temper < 0.d0'
        stop
      endif
      write(6,*) 'T (K)=',temper
c     reading outputfile names
      CALL read_a_line(25,line)
      read (line,*) Qout        
      if (Qout) then
        CALL read_a_line(25,line)
        read (line,*) fname2,fname3,fname4
        write(6,*) fname2,' outputfile name for Mean-Square' 
     $                  //' Displacements'
        write(6,*) fname3,' outputfile name for Self-Diffusion' 
     $                  //' Constants'
        write(6,*) fname4,' outputfile name for Ionic conductivity'
      endif
c     reading number of chain types
      CALL read_a_line(25,line)
      read (line,*) nptypes
      if (nptypes.le.0) then
        write(6,*) 'Number of chain types is lower than or equal'
     $           //' to 0'
        stop
      endif
      if (nptypes.gt.maxmtypes) then
        write(6,*) 'Number of chain types is greather than ',maxmtypes
        stop
      endif
      write(6,*) nptypes,' number of chain types'
c     reading label of chain types
      CALL read_a_line(25,line)
      read (line,*) (labeltyp(i),i=1,nptypes)
      write(6,*) 'Label of chain types : ',(labeltyp(i),i=1,nptypes)
c     reading regressions for obtaining self-diffusion constant
      CALL read_a_line(25,line)
      read (line,*) Qregr
      if (Qregr) then
        CALL read_a_line(25,line)
        read (line,*) fname5
        write(6,*) fname5,' outputfile name for linear least square '
     $                  //' regressions'
      endif
c     reading init value and final value for elapsed time 
      CALL read_a_line(25,line)
      read (line,*) initval,endval
      if (initval.lt.1) then
        write(6,*) 'Initial elapsed time value is lower than 1'
        stop
      endif 
      if (endval.lt.initval) then
        write(6,*) 'Final elapsed time value is lower than'
     $           //' initial elapsed time value'
        stop
      endif
      write(6,*) initval,' init value for elapsed time'
      write(6,*) endval,' final value for elapsed time' 
      close(25)
      return
      end
C
      SUBROUTINE read12()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer number,intert,itype,jtype,nq,iinter,jinter,icheck,jcheck
      integer inontype,jnontype,inb,irow,icol,ibond,ibend
      integer itort,ideform,ii,n2
      real*8 a,b,c,d,remass,f1,f2,f3
      integer non_of_charge(maxcharges)
      integer typen(maxtypes,maxtypes)
      character*2 int
      character*3 label1,label2
      character*21 label
      character*144 line
      integer i,nbendt,ntortt,ndeformt
      logical ok
C
C
      ncharge = 0
      lpolarizable=.false.
      open(12,file="ff.dat",status="old") 
      write(6,*) '**** READING ff.dat FILE ***'
      CALL read_a_line(12,line)
      read (line,*) number
      if (number.gt.maxtypes) then
        write(6,*) '**** ERROR IN ff.dat FILE ***'
        write(6,*) 'Number of non-bonded types = ',number
        write(6,*) 'maxtypes  = ',maxtypes
        write(6,*) 'Number of non-bonded types is greather' 
     &           //' than maxtypes'
        stop
      endif
      if (number.lt.maxtypes) then
        write(6,*) '**** WARNING IN ff.dat FILE ***'
        write(6,*) 'Number of non-bonded types = ',number
        write(6,*) 'maxtypes  = ',maxtypes
        write(6,*) 'Number of non-bonded types is lower' 
     &           //' than maxtypes'
      endif
C
C     *****assign typen initially           
C
      intert = 0
      do itype = 1,number
        do jtype = itype,number
          intert = intert + 1
          typen(itype,jtype) = intert
          typen(jtype,itype) = intert
         end do
      end do
      CALL read_a_line(12,line)
      write(6,*) "Nonboned self-terms"
      do itype = 1,number
        nq = 0
        read (line,'(a3)') non_labels(itype)                 
        intert =  typen(itype,itype)
        read (line(4:144),*) a,b,c,d,remass
        write(6,'(a3,x,4F15.2,F10.4)')non_labels(itype),a,b,c,d,remass
        nonbonded(1,intert) = a
        nonbonded(2,intert) = b
        nonbonded(3,intert) = c
        electrostatic(intert,2) = -d*2.0d0
        atmasses(itype) = remass
C      
C       *******look for charges for this type
C
        CALL read_a_line(12,line)
        if (line(1:1) .ne. ' ') then
          nq = nq + 1
          write(int,'(i2)') nq
          ncharge = ncharge +  1
          if (ncharge.gt.maxcharges) then
            write(6,*) '**** ERROR IN ff.dat FILE ***'
            write(6,*) 'Number of force center types = ',ncharge
            write(6,*) 'maxcharges  = ',maxcharges
            write(6,*) 'Number of force center types is greather'
     &              //' than maxtypes'
            stop
          endif
          q(ncharge) = 0.0d0
          pol(ncharge) = 0.0d0
          atom_labels(ncharge) = non_labels(itype)//int
          non_of_charge(ncharge) = itype
          write (6,*) 'no charge and polarizability for atom ',
     $                 atom_labels(ncharge),
     $                ' was found:  a zero charge is assumed'
        else
          do while (line(1:1) .eq. ' ')
            nq = nq + 1
            write(int,'(i2)') nq
            ncharge = ncharge + 1
            if (ncharge.gt.maxcharges) then
              write(6,*) '**** ERROR IN ff.dat FILE ***'
              write(6,*) 'Number of force center types = ',ncharge
              write(6,*) 'maxcharges  = ',maxcharges
              write(6,*) 'Number of force center types is greather'
     &                 //' than maxtypes'
              stop
            endif
            atom_labels(ncharge) = non_labels(itype)//int
            read (line(2:144),*) q(ncharge),pol(ncharge)
            write(6,'("Q=",F12.4," pol.=",F12.4)')
     $              q(ncharge),pol(ncharge)
            if (pol(ncharge).gt.1.0e-4) lpolarizable=.true.
            non_of_charge(ncharge) = itype                   
            CALL read_a_line(12,line)
          end do
        end if
      end do ! next itype
      if (ncharge.lt.maxcharges) then
        write(6,*) '**** WARNING IN ff.dat FILE ***'
        write(6,*) 'Number of force center types = ',ncharge
        write(6,*) 'maxcharges  = ',maxcharges
        write(6,*) 'Number of force center types is lower'
     &           //' than maxtypes'
      endif
C
C     *****assign default for off diagonal
C
      do itype = 1,number
        iinter =  typen(itype,itype)
        do jtype = itype+1,number
          jinter =  typen(jtype,jtype)
          intert =  typen(itype,jtype)
          a = sqrt(nonbonded(1,iinter)*nonbonded(1,jinter))
          b = 0.5*(nonbonded(2,iinter)+nonbonded(2,jinter))
          c = sqrt(nonbonded(3,iinter)*nonbonded(3,jinter))
          nonbonded(1,intert) = a
          nonbonded(2,intert) = b
          nonbonded(3,intert) = c
        end do
      end do
C
C     *****read non-default nonbonded interactions
C
      do while (line(1:1) .ne. '!')
        read(line,'(a3)') label1
        icheck = 0
        ok = .false.
        do while (.not.ok .and. icheck.lt.number)
          icheck = icheck + 1
          if (label1 .eq. non_labels(icheck)) then
            itype = icheck
            ok = .true.
          end if
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN ff.dat FILE ***'
          write(6,*) 'Incorrect atom label'
          stop
        endif 
        read (line(5:7),'(a3)') label2
        jcheck = 0
        ok = .false.
        do while (.not.ok .and. jcheck.lt.number)
          jcheck = jcheck + 1
          if (label2 .eq. non_labels(jcheck)) then
            jtype = jcheck
            ok = .true.
          end if
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN ff.dat FILE ***'
          write(6,*) 'Incorrect atom label'
          stop
        endif
        intert =  typen(itype,jtype)
        read (line(8:144),*) a,b,c,d
        write(6,'(a3,x,a3,4F15.2,F10.4)')
     $     label1,label2,a,b,c,d
        nonbonded(1,intert) = a
        nonbonded(2,intert) = b
        nonbonded(3,intert) = c
        electrostatic(intert,2) = -d*2.0d0
        CALL read_a_line(12,line)
      end do
C
      intert = 0
      do itype = 1,ncharge
        inontype = non_of_charge(itype)                   
        do jtype = itype,ncharge
          jnontype = non_of_charge(jtype)                   
          intert = intert + 1
          typee(itype,jtype) = intert
          typee(jtype,itype) = intert
          inb = typen(inontype,jnontype)
          map(intert) = inb
         end do
      end do
      do irow = 1,ncharge
        do icol = irow,ncharge
          itype = typee(irow,icol)
          electrostatic(itype,1) = 332.08d0*q(irow)*q(icol)
        end do
      end do
C
C     *****valence force field
C
      CALL read_a_line(12,line)
      read (line,*) nbondt
      write(6,*) "Bonds"
      do ibond = 1,nbondt
        CALL read_a_line(12,line)
        label = line(1:11)
        read (line(12:144),*) f1,f2,f3
        write(6,'(a10,x,3F12.3)') label,f1,f2,f3
        stretch(1,ibond) = f1
        stretch(2,ibond) = f2
        stretch(3,ibond) = f3
      end do
      CALL read_a_line(12,line)
      read (line,*) nbendt
      write(6,*) "Bends"
      do ibend = 1,nbendt
        CALL read_a_line(12,line)
        label = line(1:15)
        read (line(16:144),*) f1,f2
        write(6,'(a15,x,2F12.3)') label,f1,f2
        bend(1,ibend) = f1
        bend(2,ibend) = f2
      end do
      CALL read_a_line(12,line)
      read (line,*) ntortt
      write(6,*) "Torsions"
      do itort = 1,ntortt
        CALL read_a_line(12,line)
        label = line(1:20)
        read (line(21:144),*)n2,(twist(ii,itort),ii=0,n2-1)
        write(6,'(a20,x,I5,8F9.5)')label,n2,(twist(ii,itort),ii=0,n2-1)
        nprms(itort) = n2
      end do
      CALL read_a_line(12,line)
      read (line,*) ndeformt
      write(6,*) "Deformations"
      do ideform = 1,ndeformt
        CALL read_a_line(12,line)
        label = line(1:20)
        read (line(21:144),*) f1
        write(6,'(a20,x,F10.3)') label,f1
        deform(ideform) = f1
      end do
 114  format (a10,10f5.1)
      CALL read_a_line(12,line)
      read (line,*) ndummytypes
      write(6,*) "Dummy atoms"
      do i=1,ndummytypes
        typedummy(i)=0
      end do 
      do itype=1,ndummytypes
        CALL read_a_line(12,line)
        label = line(1:20)
        read(line(21:144),*) i,adummy(itype),bdummy(itype),
     $                     cdummy(itype),LpGeomType(itype),
     $  LpBendAtomType(1,itype),LpBendAtomType(2,itype),
     $  LpBendAtomType(3,itype) ! added in v2.13
        write(6,'(a20,I3,3F12.4,4I3)')label,i,adummy(itype),
     $      bdummy(itype),cdummy(itype),LpGeomType(itype),
     $  LpBendAtomType(1,itype),LpBendAtomType(2,itype),
     $  LpBendAtomType(3,itype) ! added in v2.13
        typedummy(i)=itype
      end do
C
      write(6,*) "finished reading force field"
C
      close(12)
      return
      end
C
      SUBROUTINE read11()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer ch,iat,ibond,itbond,j,ibend,ib1,ib2,nchains
      integer imult,itemp,ich,icheck1,icheck2,itort,ideform,ib
      integer iba,itest,itbend,ittort,itdefs,ibase
      integer nbendsch(maxnch),ntortsch(maxnch),nbondex(maxnch)
      character*144 line
      logical ok
C
C
C     *****read in data
C
      itbond = 0
      itbend = 0
      ittort = 0
      itdefs = 0
      open(11,file="connectivity.dat",status="old")
      write(6,*) '**** READING connectivity.dat FILE ***'
      CALL read_a_line(11,line)
      read (line,*) nchains, nions
      nch = nchains + nions
      nat = 0
      nbonds = 0
      nbends = 0
      ntorts = 0
      ndeforms = 0
      do ich = 1, nch
        CALL read_a_line(11,line)
        read (line,*) natch(ich),nbondsch(ich),
     +     nbendsch(ich),ntortsch(ich),ndeformsch(ich)
        nat = nat + natch(ich)
        nbondex(ich) = nbonds
        nbonds = nbonds + nbondsch(ich)
        nbends = nbends + nbendsch(ich)
        ntorts = ntorts + ntortsch(ich)
        ndeforms = ndeforms + ndeformsch(ich)
      end do
      write (6,*) 'nat = ',nat
      write (6,*) 'nbonds = ',nbonds
      write (6,*) 'nbends = ',nbends
      write (6,*) 'ntorts = ',ntorts
      write (6,*) 'ndeforms = ',ndeforms
      write (6,*) 'nions = ',nions
      write (6,*) 'reading bonds'
      do ich = 1,nch
        if (nbondsch(ich) .eq. 0)then
          CALL read_a_line(11,line)
          read (line,*) iat
          chain(iat) = ich
        end if
        ibond = 0
        do while (ibond.lt.nbondsch(ich))
          ibond = ibond + 1 
          CALL read_a_line(11,line)
          itbond = itbond + 1
          read (line,*) (bonds(j,itbond), j=1,3)
        end do
      end do
      write (6,*) 'reading bends'
      do ich = 1,nch
        ibase = nbondex(ich)
        ibend = 0
        do while (ibend.lt.nbendsch(ich))
          ibend = ibend + 1
          CALL read_a_line(11,line)
          itbend = itbend + 1
          read (line,*) (bends(j,itbend), j=1,4)
C
C     *****determine which bonds make up each bend
C
          ib1 = bends(1,itbend)
          ib2 = bends(2,itbend)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              bends(5,itbend) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then 
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'bend:first bond not found'
            stop
          endif
          ib1 = bends(2,itbend)
          ib2 = bends(3,itbend)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              bends(6,itbend) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'bend:second bond not found'
            stop
          endif
        end do
      end do
      write (6,*) 'reading torsions'
      do ich = 1,nch
        ibase = nbondex(ich)
        itort = 0
        do while (itort.lt.ntortsch(ich))
          itort = itort + 1
          CALL read_a_line(11,line)
          ittort = ittort + 1
          read (line,*) (torts(j,ittort), j=1,5)
C
C     *****determine which bonds make up each torsion
C
          ib1 = torts(1,ittort)
          ib2 = torts(2,ittort)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              torts(6,ittort) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:first bond not found'
            stop
          endif
          ib1 = torts(2,ittort)
          ib2 = torts(3,ittort)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              torts(7,ittort) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:second bond not found'
            stop
          endif
          ib1 = torts(3,ittort)
          ib2 = torts(4,ittort)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              torts(8,ittort) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'torsion:third bond not found'
            stop
          endif
        end do
      end do
      write (6,*) 'reading deformations'
      do ich = 1,nch
        ibase = nbondex(ich)
        ideform = 0
        do while (ideform.lt.ndeformsch(ich))
          ideform = ideform + 1
          CALL read_a_line(11,line)
          itdefs = itdefs + 1
          read (line,*) (deforms(j,itdefs), j=1,5),idpar(itdefs)
C
C     *****determine which bonds make up each deformation
C
          ib1 = deforms(1,itdefs)
          ib2 = deforms(2,itdefs)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              deforms(6,itdefs) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:first bond not found'
            stop
          endif
          ib1 = deforms(2,itdefs)
          ib2 = deforms(3,itdefs)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              deforms(7,itdefs) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:second bond not found'
            stop
          endif
          ib1 = deforms(2,itdefs)
          ib2 = deforms(4,itdefs)
          imult = 1
          if (ib2 .lt. ib1) then
            imult = -1
            itemp = ib1
            ib1 = ib2
            ib2 = itemp
          end if
          ok = .false.
          ib = 0
          do while (ib.lt.nbondsch(ich) .and. .not.ok)
            ib = ib + 1
            ibond = ibase + ib
            icheck1 = bonds(1,ibond)
            icheck2 = bonds(2,ibond)
            if (icheck1 .eq. ib1 .and. 
     +          icheck2 .eq. ib2) then
              deforms(8,itdefs) = imult*ibond
              ok = .true.
            end if
          end do
          if (.not.ok) then
            write(6,*) '**** ERROR IN connectivity.dat FILE ***'
            write (6,*) 'deform:third bond not found'
            stop
          endif
        end do
      end do
C
C     *****determine chain of each atom
C
      itbond = 0
      do ich = 1, nch
        ib = 0
        do while (ib.lt.nbondsch(ich))
          ib = ib + 1
          itbond = itbond + 1
          do iba = 1,2
            itest = bonds(iba,itbond)
            chain(itest) = ich
          end do
        end do
      end do
C     
      close(11)
      return 
      end 
C
      SUBROUTINE read26()
C
      implicit none
      include "params.h"
      include "dimensions.h"
      include "commons.h"
C
C     *****local variables
C
      integer kk,iat,lstart,istart,iend,icharge,itype,imap,inos
      character*144 line
      character*5 check
      character*2 int
      real*8 shift(3)
      logical ok
C
C
C     *****begin read
C
      shift(1) = 10000.d0
      shift(2) = 10000.d0
      shift(3) = 10000.d0
C
C
      do iat = 1, nat
        ldummy(iat)=.false.
      end do
C
      open(26,file="coords.inp",status="old")
      write(6,*) '**** READING coords.inp FILE ***'
      ndummy=0
      write(6,*) 'atom----label----mass [g/mol]'
      do iat = 1, nat
        CALL read_a_line(26,line)
        lstart = 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(1,iat)
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(2,iat)
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) x(3,iat)
        do kk = 1,3
         if (x(kk,iat) .lt. shift(kk)) shift(kk) = x(kk,iat)
        end do
C
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:istart+2),'(a3)') check 
C
        lstart = iend + 1
        CALL parse_line(line,lstart,istart,iend)
        read(line(istart:iend),*) icharge
        write (int,'(i2)') icharge
        check = check(1:3)//int
C
C       *****assign atom type
C
        itype = 0
        ok = .false.
        do while (.not.ok .and. itype.lt.maxcharges)
          itype = itype + 1
          if (check .eq. atom_labels(itype)) then
            atomtype(iat) = itype
            if (typedummy(itype).gt.0) then 
              ldummy(iat)=.true.
              ndummy=ndummy+1
            end if
            imap = map(itype)
            mass(iat) = atmasses(imap)
            write(6,*) iat,atom_labels(itype),mass(iat)
            ok = .true.
          end if
        end do
        if (.not.ok) then
          write(6,*) '**** ERROR IN coords.inp FILE ***'
          write (6,*) 'atomtype not found'
          stop
        endif
C
        CALL read_a_line(26,line)
        read (line,*) (v(kk,iat),kk=1,3)
      end do ! next iat
C
C     ***** read extended lagrangian variables
C
      CALL read_a_line(26,line)
      read(line,*)box
      write(6,*)
      write(6,*) "initial box=",box
      CALL read_a_line(26,line)
      read(line,*)(xlogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)(vlogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)(glogs(inos),inos = 1,nnos)
      CALL read_a_line(26,line)
      read(line,*)xlogv
      CALL read_a_line(26,line)
      read(line,*)vlogv
      CALL read_a_line(26,line)
      read(line,*)glogv
C
C     *******shift positions of necessary
C
      if (shift(1) .lt. 0.d0 .or. shift(2) .lt. 0.d0 .or.
     $    shift(3) .lt. 0.d0) then
        write (6,*) 'shifting positions'
        do iat = 1,nat
          do kk = 1,3  
            x(kk,iat) = x(kk,iat) - shift(kk) + 1.d-8
          end do
        end do
      end if
C
      close(26)
      return
      end
C
      SUBROUTINE read_a_line(iunit,line)
C
      implicit none
C
C     *****shared variables
C
      integer iunit
      character*144 line
C
1     read(iunit,'(a144)',end=100) line
      if (line(1:1) .eq. '*') goto 1
      return
100   continue
      write (6,*) 'end of file ',iunit,' was reached'
      stop
      end
C
      SUBROUTINE parse_line(line,lstart,istart,iend)
C
      implicit none
C
C     *****shared variables
C
      integer lstart,istart,iend
      character*144 line
C
C     *****local variables
C
      character*1 value
      integer ipos
C
      ipos = lstart -1
      value = ' '
      do while (value .eq. ' ')
        ipos = ipos + 1
        value = line(ipos:ipos)
      end do
      istart = ipos
      do while (value .ne. ' ')
        ipos = ipos + 1
        value = line(ipos:ipos)
      end do
      iend = ipos - 1
C
      return
      end
